<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Class: Phone</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Class: Phone</h1>

    




<section>

<header>
    
        <h2><span class="attribs"><span class="type-signature"></span></span>
            <span class="ancestors"><a href="module-phone.html">phone</a>~</span>Phone<span class="signature">(config, app)</span><span class="type-signature"></span></h2>
        
            <div class="class-description"><p>Phone interface Module to connect to twilio API</p>
<p>Twilio Account Webhooks need to be set to HTTP GET
the phones address routing for incomming call and sms is build like this:
http://<plai webaddress>:<plai port>/<phone name>/sms
http://<plai webaddress>:<plai port>/<phone name>/call</p></div>
        
    
</header>

<article>
    <div class="container-overview">
    
        

    
    <h2>Constructor</h2>
    

    
    <h4 class="name" id="Phone"><span class="type-signature"></span>new Phone<span class="signature">(config, app)</span><span class="type-signature"></span></h4>
    

    











    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>config</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>has to contain all properties necessary to configure twilio interface</p>
                <h6>Properties</h6>
                

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        
        <th>Attributes</th>
        

        
        <th>Default</th>
        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>name</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>name for this twilio phone instance. First part for Twilio Request address</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>settings.sid</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>twilio SID</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>settings.token</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>twilio Token</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>settings.telnumber</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>twilio Telnumber</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>settings.audiofiles</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                
                    &lt;optional><br>
                

                

                
                </td>
            

            
                <td class="default">
                
                    './public/audio/&lt;config.name>'
                
                </td>
            

            <td class="description last"><p>path that is prepended to audiofiles for external access by twilio client</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>url</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            
                <td class="attributes">
                

                

                
                </td>
            

            
                <td class="default">
                
                </td>
            

            <td class="description last"><p>game webaddress and port</p></td>
        </tr>

    
    </tbody>
</table>

            </td>
        </tr>

    

        <tr>
            
                <td class="name"><code>app</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>Express app forwarded from plai framework</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line31">line 31</a>
    </li></ul></dd>
    

    

    

    
</dl>


















    
    </div>

    

    

    

    

    

    

    
        <h3 class="subsection-title">Members</h3>

        
            
<h4 class="name" id="locked"><span class="type-signature"></span>locked<span class="type-signature"></span></h4>




<div class="description">
    <p>allows to mute outgoing sms to save money or to stop sending in case of emergency</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line47">line 47</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="pending"><span class="type-signature"></span>pending<span class="type-signature"></span></h4>




<div class="description">
    <p>stores a list of objects identified by telnumber key that allow forwarding incoming events 
pending gets a new entry on incoming events that have no routing</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line44">line 44</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
            
<h4 class="name" id="routing"><span class="type-signature"></span>routing<span class="type-signature"></span></h4>




<div class="description">
    <p>stores objects identified by telnumber key, that allow forwarding callstatus messages, incoming calls and incoming sms</p>
</div>







<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line40">line 40</a>
    </li></ul></dd>
    

    

    

    
</dl>






        
    

    
        <h3 class="subsection-title">Methods</h3>

        
            

    

    
    <h4 class="name" id="call"><span class="type-signature"></span>call<span class="signature">(number)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>call out
See Twilio Reference here:
https://<a href="http://www.twilio.com/docs/api/voice/making-calls#url-parameter">www.twilio.com/docs/api/voice/making-calls#url-parameter</a>
Example for Status Callbacks:
https://<a href="http://www.twilio.com/docs/api/voice/making-calls#make-a-call-and-monitor-progress-events">www.twilio.com/docs/api/voice/making-calls#make-a-call-and-monitor-progress-events</a></p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>number</code></td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>telnumber to call</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>properties.file</code></td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>path/to/audiofile to play when call established</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>properties.established</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            

            <td class="description last"><p>is called when call was established (in a closed handler this would be done internally)</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>properties.interrupt</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            

            <td class="description last"><p>is called when call couldnt be established</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>properties.ended</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            

            <td class="description last"><p>is called with duration when established call is finished</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line392">line 392</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="callIn"><span class="type-signature"></span>callIn<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>handle incomming call requests from twilio</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line193">line 193</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="callStatus"><span class="type-signature"></span>callStatus<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>handle call status requests from twilio</p>
<p>clean up pending queue if theres something left</p>
<p>check for routing and get reaction from callbacks accordingly</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line232">line 232</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="cancelCallIn"><span class="type-signature"></span>cancelCallIn<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>cancel callin routing for telnumber and path</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line476">line 476</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="cancelSmsIn"><span class="type-signature"></span>cancelSmsIn<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>cancel sms in routing for telnumber and path</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line551">line 551</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="close"><span class="type-signature"></span>close<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>remove express routings
not sure if twilio client also needs to or can be closed</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line121">line 121</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="reconnect"><span class="type-signature"></span>reconnect<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>(re-)create twilio client</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line61">line 61</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="registerCallIn"><span class="type-signature"></span>registerCallIn<span class="signature">(telnumber, path, callback)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>add response for telnumber on incomming call.
if there is already a routing registered for telnumber and path, overwrite. (Though this case should never occur)
stack callin routing for same number. On callin event the most recent registered routing is used
store path to allow canceling the right routing Phone.cancelCallIn</p>
<p>if there is an incomming call request pending for the telnumber, respond to it</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>telnumber</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>telnumber of client may be calling</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>


            
            </td>

            

            

            <td class="description last"><p>path the cue is in that registers callin</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>functions to call on incoming callin events. Is called on incomming call for telnumber</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line446">line 446</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="registerSmsIn"><span class="type-signature"></span>registerSmsIn<span class="signature">(telnumber, path, callback)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>add response for telnumber on incomming sms.
if there is already a routing registered for telnumber and path, overwrite. (Though this case should never occur)
stack sms routing for same number. On smsin event the most recent registered routing is used
store path to allow canceling the right routing Phone.cancelSmsIn</p>
<p>if there is an incomming sms request pending for the telnumber, respond to it</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>telnumber</code></td>
            

            <td class="type">
            
                
<span class="param-type">string</span>


            
            </td>

            

            

            <td class="description last"><p>telnumber of client may be sending sms</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>path</code></td>
            

            <td class="type">
            
                
<span class="param-type">Array</span>


            
            </td>

            

            

            <td class="description last"><p>path the cue is in that registers smsin</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">Object</span>


            
            </td>

            

            

            <td class="description last"><p>functions to call on incoming sms events. Is called on incomming sms for telnumber</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line522">line 522</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="sendSms"><span class="type-signature"></span>sendSms<span class="signature">(telnumber, text, callback)</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>Send sms</p>
</div>









    <h5>Parameters:</h5>
    

<table class="params">
    <thead>
    <tr>
        
        <th>Name</th>
        

        <th>Type</th>

        

        

        <th class="last">Description</th>
    </tr>
    </thead>

    <tbody>
    

        <tr>
            
                <td class="name"><code>telnumber</code></td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>number to send to</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>text</code></td>
            

            <td class="type">
            
                
<span class="param-type">String</span>


            
            </td>

            

            

            <td class="description last"><p>text of message to send</p></td>
        </tr>

    

        <tr>
            
                <td class="name"><code>callback</code></td>
            

            <td class="type">
            
                
<span class="param-type">function</span>


            
            </td>

            

            

            <td class="description last"><p>function to call when done sending</p></td>
        </tr>

    
    </tbody>
</table>






<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line365">line 365</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
            

    

    
    <h4 class="name" id="smsIn"><span class="type-signature"></span>smsIn<span class="signature">()</span><span class="type-signature"></span></h4>
    

    



<div class="description">
    <p>handles sms in requests from twilio</p>
<p>uses request.query to evaluate what message came from whom
if 'from' property is a registered number, forward to registered callback</p>
<p>the callbacks registered are in a stack per telnumber. smsIn always uses the most recent entry, which is on index 0
routings are added on array bottom see Phone.registerSmsIn </p>
<p>if query is empty, try body. Usefull for test requests with curl or via browser url</p>
<p>If there is no routing registered for the telnumber and if the Phone has a default level defined sms in is pending.<br>That means a callback is stored in pending object for this telnumber and allows the next routing registered for this number to imediatly reply</p>
</div>













<dl class="details">

    

    

    

    

    

    

    

    

    

    

    

    

    
    <dt class="tag-source">Source:</dt>
    <dd class="tag-source"><ul class="dummy"><li>
        <a href="plugins_twilio_phone.js.html">plugins/twilio/phone.js</a>, <a href="plugins_twilio_phone.js.html#line139">line 139</a>
    </li></ul></dd>
    

    

    

    
</dl>


















        
    

    

    
</article>

</section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Modules</h3><ul><li><a href="module-ableton.html">ableton</a></li><li><a href="module-control.html">control</a></li><li><a href="module-d-pro.html">d-pro</a></li><li><a href="module-device.html">device</a></li><li><a href="module-devices.html">devices</a></li><li><a href="module-errors.html">errors</a></li><li><a href="module-file.html">file</a></li><li><a href="module-game.html">game</a></li><li><a href="module-index.html">index</a></li><li><a href="module-logic.html">logic</a></li><li><a href="module-medley.html">medley</a></li><li><a href="module-mongo.html">mongo</a></li><li><a href="module-ne.html">ne</a></li><li><a href="module-phone.html">phone</a></li><li><a href="module-plugin.html">plugin</a></li><li><a href="module-session.html">session</a></li><li><a href="module-sound.html">sound</a></li><li><a href="module-telegram.html">telegram</a></li><li><a href="module-tradfri.html">tradfri</a></li><li><a href="module-twilio.html">twilio</a></li><li><a href="module-variables.html">variables</a></li></ul><h3>Classes</h3><ul><li><a href="CollectionAPI.html">CollectionAPI</a></li><li><a href="Data.html">Data</a></li><li><a href="module-ableton-Liveset.html">Liveset</a></li><li><a href="module-d-pro-Show.html">Show</a></li><li><a href="module-device-Device.html">Device</a></li><li><a href="module-device-Mididevice.html">Mididevice</a></li><li><a href="module-device-OSCdevice.html">OSCdevice</a></li><li><a href="module-device-Serialdevice.html">Serialdevice</a></li><li><a href="module-device-TCPdevice.html">TCPdevice</a></li><li><a href="module-device-UDPdevice.html">UDPdevice</a></li><li><a href="module-device-Webdevice.html">Webdevice</a></li><li><a href="module-errors-DesignError.html">DesignError</a></li><li><a href="module-game-Game.html">Game</a></li><li><a href="module-logic-Condition.html">Condition</a></li><li><a href="module-logic-Listener.html">Listener</a></li><li><a href="module-medley-Log.html">Log</a></li><li><a href="module-mongo-Collection.html">Collection</a></li><li><a href="module-mongo-Database.html">Database</a></li><li><a href="module-mongo-Document.html">Document</a></li><li><a href="module-ne-Collection.html">Collection</a></li><li><a href="module-ne-Database.html">Database</a></li><li><a href="module-ne-Document.html">Document</a></li><li><a href="module-phone-Phone.html">Phone</a></li><li><a href="module-plugin-Collection.html">Collection</a></li><li><a href="module-plugin-Item.html">Item</a></li><li><a href="module-plugin-Plugin.html">Plugin</a></li><li><a href="module-session-Session.html">Session</a></li><li><a href="module-telegram-Bot.html">Bot</a></li><li><a href="module-twilio-Call.html">Call</a></li><li><a href="module-twilio-CallIn.html">CallIn</a></li><li><a href="module-twilio-SmsIn.html">SmsIn</a></li><li><a href="module-twilio-Switchboard.html">Switchboard</a></li><li><a href="module-variables-Variables.html">Variables</a></li></ul><h3>Global</h3><ul><li><a href="global.html#assignIntro">assignIntro</a></li><li><a href="global.html#assignStory">assignStory</a></li><li><a href="global.html#assignTaskC">assignTaskC</a></li><li><a href="global.html#attendance">attendance</a></li><li><a href="global.html#cancelPlayerSessions">cancelPlayerSessions</a></li><li><a href="global.html#cancelSessions">cancelSessions</a></li><li><a href="global.html#checkQueue">checkQueue</a></li><li><a href="global.html#cooperation">cooperation</a></li><li><a href="global.html#getLocationText">getLocationText</a></li><li><a href="global.html#getLoginLink">getLoginLink</a></li><li><a href="global.html#getPlace">getPlace</a></li><li><a href="global.html#getReader">getReader</a></li><li><a href="global.html#jobData">jobData</a></li><li><a href="global.html#left">left</a></li><li><a href="global.html#nextJob">nextJob</a></li><li><a href="global.html#since">since</a></li><li><a href="global.html#startValues">startValues</a></li><li><a href="global.html#timestamp">timestamp</a></li><li><a href="global.html#updateQueue">updateQueue</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Tue Dec 17 2019 17:26:50 GMT+0100 (CET)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>